## mingw-w64-flecs-4.1.2-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
cmake_policy(SET CMP0063 NEW)

project(flecs LANGUAGES C)

option(FLECS_STATIC "Build static flecs lib" ON)
option(FLECS_SHARED "Build shared flecs lib" ON)
option(FLECS_PIC "Compile static flecs lib with position independent code (PIC)" ON)
option(FLECS_TESTS "Build flecs tests" OFF)

include(cmake/target_default_compile_warnings.cmake)
include(cmake/target_default_compile_options.cmake)

# Automatically generate the same folder structure in Visual Studio as we have on disk
macro(GroupSources curdir)
	file(GLOB children RELATIVE ${PROJECT_SOURCE_DIR}/${curdir} ${PROJECT_SOURCE_DIR}/${curdir}/*)
	foreach(child ${children})
		if(IS_DIRECTORY ${PROJECT_SOURCE_DIR}/${curdir}/${child})
			GroupSources(${curdir}/${child})
		else()
			string(REPLACE "/" "\\" groupname ${curdir})
            source_group(${groupname} FILES ${PROJECT_SOURCE_DIR}/${curdir}/${child})
		endif()
	endforeach()
endmacro()

file(GLOB children RELATIVE ${PROJECT_SOURCE_DIR}/. ${PROJECT_SOURCE_DIR}/./*)
foreach(child ${children})
	if(IS_DIRECTORY ${PROJECT_SOURCE_DIR}/${curdir}/${child})
		GroupSources(${child})
	endif()
endforeach()

file(GLOB_RECURSE INC include/*.h include/*.hpp)
file(GLOB_RECURSE SRC src/*.c)

set(FLECS_TARGETS "")

macro(add_flecs_target TARGET CONFIG)
    add_library(${TARGET} ${CONFIG} ${INC} ${SRC})
    add_library(flecs::${TARGET} ALIAS ${TARGET})

    target_default_compile_options_c(${TARGET})
    target_default_compile_warnings_c(${TARGET})
    if(WIN32)
        target_link_libraries(${TARGET} wsock32 ws2_32 dbghelp)
    endif()

    if(CMAKE_SYSTEM_NAME STREQUAL "Android")
        target_include_directories(${TARGET} PRIVATE  
        "${CMAKE_ANDROID_NDK}/toolchains/llvm/prebuilt/windows-x86_64/include/")  
        message(STATUS "building Android project...")
    endif()

    if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
        target_link_libraries(${TARGET} pthread)
    endif()

    if(FLECS_PIC)
        set_property(TARGET ${TARGET} PROPERTY POSITION_INDEPENDENT_CODE ON)
    endif()

    target_include_directories(${TARGET} PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

    list(APPEND FLECS_TARGETS ${TARGET})
endmacro()

if(FLECS_SHARED)
    add_flecs_target(flecs SHARED)
endif()

if(FLECS_STATIC)
    add_flecs_target(flecs_static STATIC)
    target_compile_definitions(flecs_static PUBLIC flecs_STATIC)
endif()

if(FLECS_TESTS)
    enable_testing()
    add_subdirectory(test)
endif()

message(STATUS "Targets: ${FLECS_TARGETS}")

# define the install steps
include(GNUInstallDirs)
install(DIRECTORY "${PROJECT_SOURCE_DIR}/include/"
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        FILES_MATCHING
        PATTERN "*.h"
        PATTERN "*.hpp"
        PATTERN "*.inl")

install(TARGETS ${FLECS_TARGETS}
        EXPORT flecs-export
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(EXPORT flecs-export
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/flecs
        NAMESPACE flecs::
        FILE flecs-config.cmake)

=== meson_options.txt ===
option('build_example', description : 'build the helloworld example', type : 'feature', value : 'auto')

=== test/CMakeLists.txt ===
project(flecs_tests LANGUAGES C CXX)

if(NOT BAKE_DIRECTORY)
  set(BAKE_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}/bake")
else()
  set(BAKE_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}/../${BAKE_DIRECTORY}")
endif()

if(NOT IS_DIRECTORY "${BAKE_DIRECTORY}")
  message(FATAL_ERROR "The CMake tests require a bake repository "
                      "at '${BAKE_DIRECTORY}'.")
endif()

macro(add_flecs_test DIRECTORY)
  get_filename_component(TEST_NAME_WE ${DIRECTORY} NAME_WE)

  file(
    GLOB_RECURSE TEST_SOURCES CONFIGURE_DEPENDS
    LIST_DIRECTORIES false
    "${DIRECTORY}/*.cpp" "${DIRECTORY}/*.c" "${DIRECTORY}/*.h")

  foreach(CURRENT_FLECS_TARGET IN LISTS FLECS_TARGETS)
    set(TEST_NAME "test_${TEST_NAME_WE}_${CURRENT_FLECS_TARGET}")
    set(CTEST_NAME "flecs_${TEST_NAME_WE}_test_${CURRENT_FLECS_TARGET}")

    message(STATUS "Adding test ${TEST_NAME}")

    add_executable("${TEST_NAME}" ${TEST_SOURCES})

    target_link_libraries("${TEST_NAME}" PUBLIC bake_base
                                                ${CURRENT_FLECS_TARGET})

    if(IS_DIRECTORY "${DIRECTORY}/include")
      target_include_directories(${TEST_NAME} PUBLIC "${DIRECTORY}/include")
    endif()

    set_target_properties(
      ${TEST_NAME}
      PROPERTIES VS_DEBUGGER_COMMAND_ARGUMENTS "-j 1"
                 VS_DEBUGGER_ENVIRONMENT
                 "BAKE_TEST_INPLACE=1\nBAKE_VERBOSITY=OK")

    add_test(NAME ${CTEST_NAME} COMMAND $<TARGET_FILE:${TEST_NAME}>)

  endforeach()
endmacro()

# Polyfill for bake
file(
  GLOB_RECURSE BAKE_SOURCES CONFIGURE_DEPENDS
  LIST_DIRECTORIES false
  "${BAKE_DIRECTORY}/src/*.c"
  "${BAKE_DIRECTORY}/src/*.h"
  "${BAKE_DIRECTORY}/drivers/test/src/*.c"
  "${BAKE_DIRECTORY}/drivers/test/src/*.h"
  "${BAKE_DIRECTORY}/util/src/*.c"
  "${BAKE_DIRECTORY}/util/src/*.h")

if(WIN32)
  list(FILTER BAKE_SOURCES EXCLUDE REGEX "src/posix")
else()
  list(FILTER BAKE_SOURCES EXCLUDE REGEX "src/win")
endif()

message(STATUS ${BAKE_DIRECTORY})

add_library(bake_base SHARED ${BAKE_SOURCES})

target_include_directories(
  bake_base PUBLIC "${BAKE_DIRECTORY}/include" "${BAKE_DIRECTORY}/util/include"
                   "${BAKE_DIRECTORY}/drivers/test/include")

target_compile_definitions(
  bake_base
  PUBLIC __BAKE__=1
  PRIVATE bake_test_EXPORTS=1 UT_IMPL=1
  _XOPEN_SOURCE=600)

if(WIN32)
  target_link_libraries(bake_base PUBLIC Dbghelp Shlwapi Ws2_32 DbgHelp)
endif()
if(UNIX AND NOT APPLE)
  target_link_libraries(bake_base PUBLIC m)
endif()

add_flecs_test("${CMAKE_CURRENT_LIST_DIR}/core")
add_flecs_test("${CMAKE_CURRENT_LIST_DIR}/addons")
add_flecs_test("${CMAKE_CURRENT_LIST_DIR}/query")
add_flecs_test("${CMAKE_CURRENT_LIST_DIR}/meta")
add_flecs_test("${CMAKE_CURRENT_LIST_DIR}/collections")
add_flecs_test("${CMAKE_CURRENT_LIST_DIR}/cpp")

=== examples/c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
cmake_policy(SET CMP0063 NEW)

project(flecs_c_examples LANGUAGES C)

set(FLECS_DIR ../..)
set(CUR_DIR ${CMAKE_CURRENT_SOURCE_DIR})
add_subdirectory(${FLECS_DIR} ${CMAKE_CURRENT_BINARY_DIR}/flecs)

include(../../cmake/target_default_compile_options.cmake)
include(../../cmake/target_default_compile_warnings.cmake)
include(../../cmake/target_default_compile_functions.cmake)

list_targets(EXAMPLES)

foreach (EXAMPLE ${EXAMPLES})
    create_target_c(${EXAMPLE} "")
    create_target_c(${EXAMPLE} "static")
endforeach ()

=== examples/build/cmake/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.7)

project (cmake_example)

set(CMAKE_CXX_STANDARD 17)

add_subdirectory (flecs)

add_executable(cmake_example main.cpp)
add_executable(cmake_example_static main.cpp)

target_link_libraries(cmake_example flecs)
target_link_libraries(cmake_example_static flecs_static)

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.su>

_realname=flecs
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-docs")
pkgver=4.1.2
pkgrel=1
pkgdesc='A fast entity component system (ECS) for C & C++ (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.flecs.dev/'
msys2_repository_url='https://github.com/SanderMertens/flecs'
license=('spdx:MIT')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-graphviz"
             "${MINGW_PACKAGE_PREFIX}-doxygen")
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs")
source=("${msys2_repository_url}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('9820e965339cca4659dc3b4547059d56889c707e9947e7cdae71847b00dafa9c')

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build .

  msg "Build documentation"
  cd "${srcdir}/${_realname}-${pkgver}"
  ${MINGW_PREFIX}/bin/doxygen.exe docs/cfg/Doxyfile
}

package_flecs() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install .

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}

package_flecs-docs() {
  pkgdesc+=" (documentation)"
  depends=()

  mkdir -p "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}"
  cp -a "${srcdir}/${_realname}-${pkgver}/docs/html" "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}/html"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;

# vim:set ts=2 sw=2 et:
